<template>
  <div class="text-center">
    <v-btn color="primary">
      Add New Project
      <v-dialog v-model="dialog" max-width="600px" activator="parent">
        <v-card>
          <v-card-text>
            <v-form class="px-3" v-model="valid" ref="form" lazy-validation>
              <v-text-field
                label="Title"
                v-model="title"
                prepend-icon="mdi-home"
                :rules="inputRules"
              >
              </v-text-field>
              <v-textarea
                label="Information"
                v-model="content"
                prepend-icon="mdi-information-outline"
                :rules="inputRules"
              ></v-textarea>

              <!-- using date-->
              <Datepicker
                v-model="date"
                range
                :partial-range="true"
                locale="de-DE"
                :format-locale="date_format"
                format="yyyy-M-dd"
              ></Datepicker>
            </v-form>
          </v-card-text>
          <v-card-actions>
            <v-btn color="primary" block @click="submit" :loading="save_data"
              >Accept</v-btn
            >
          </v-card-actions>
        </v-card>
      </v-dialog>
    </v-btn>
  </div>
</template>

<script setup lang="ts">
import { ref } from "vue";
import format from "date-fns/format";
import { de } from "date-fns/locale";

import Datepicker from "@vuepic/vue-datepicker";
import "@vuepic/vue-datepicker/dist/main.css";

const form = ref<HTMLFormElement | null>(null);

const dialog = ref(false);
const save_data = ref(false);

const valid = ref(true);

const title = ref("");
const content = ref("");
const date = ref(null);

const date_format = ref(de);

let inputRules = [
  (v: String) => v.length >= 3 || "Minimum length is 3 characters",
];

function submit() {
  if (valid.value) {
    save_data.value = true;
    console.log(title.value, content.value);
    save2db();
    dialog.value = false;
  }
}

function save2db() {
  console.log("saving 2 db ...");
  const project_data = {
    title: title.value,
    content: content.value,
    //due: format(date.value, 'yyyy-M-dd'),
    start_end: date.value,
    person: "Anna",
    status: "ongoing",
  };

  console.log(project_data);
  console.log("now serialised:");
  console.log(JSON.stringify(project_data));

  const db_URL = "http://192.168.178.3:3000/todo_items";

  fetch(db_URL, {
    method: "POST", // or 'PUT'
    headers: {
      "Content-Type": "application/json",
    },
    body: JSON.stringify(project_data),
  })
    .then((response) => response.json())
    .then((project_data) => {
      console.log("Success:", project_data);
      save_data.value = false;
    })
    .catch((error) => {
      console.error("Error:", error);
    });
}
</script>

<style scoped></style>
